mod modem;

use std;
use std::io::{BufReader, BufWriter, Cursor};
use std::io::{Read, Write};
use esp_idf_sys as _; // If using the `binstart` feature of `esp-idf-sys`, always keep this module imported

fn start_loop<R: Read, W: Write>(_m: &mut modem::Modem<R, W>) -> () {
    println!("Starting rx/tx loop (not implemented yet) ...");
}

struct Ap<'a> {
    apn: &'a str,
    username: &'a str,
    password: &'a str,
}

const A1: Ap = Ap {
    apn: "internet",
    username: "internet",
    password: "internet",
};

fn main() {
    println!("Starting GPRS ...");

    let rx = Cursor::new(Vec::new());
    let tx = Cursor::new(Vec::new());
    let mut sim800l = modem::Modem::new(BufReader::new(rx), BufWriter::new(tx));

    match sim800l.connect_to_gprs_ap(A1.apn, A1.username, A1.password) {
        Ok(_) => start_loop(&mut sim800l),
        Err(e) => println!("{}", e),
    }
}
